/*********************************************************************
	Rhapsody	: 8.0.6 
	Login		: GB080220
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: Publisher
//!	Generated Date	: Fri, 18, Dec 2015  
	File Path	: DefaultComponent\DefaultConfig\Publisher.h
*********************************************************************/

#ifndef Publisher_H
#define Publisher_H

//## auto_generated
#include <oxf\oxf.h>
//## auto_generated
#include "Default.h"
//## auto_generated
#include <oxf\omreactive.h>
//## auto_generated
#include <oxf\state.h>
//## auto_generated
#include <oxf\event.h>
//## auto_generated
#include <oxf\omcollec.h>
//## auto_generated
#include <aom\aom.h>
//## auto_generated
#include <oxf\omthread.h>
//## operation regSubscriber(Subscriber)
class Subscriber;

//## package Default

//## class Publisher
class Publisher : public OMReactive {
public :

#ifdef _OMINSTRUMENT
    friend class OMAnimatedPublisher;
#endif // _OMINSTRUMENT

    ////    Constructors and destructors    ////
    
    //## auto_generated
    ~Publisher();
    
    ////    Additional operations    ////
    
    //## auto_generated
    OMIterator<Subscriber*> getItsSubscriberList() const;
    
    //## auto_generated
    void removeItsSubscriberList(Subscriber* p_Subscriber);
    
    //## auto_generated
    void clearItsSubscriberList();
    
    //## auto_generated
    virtual bool startBehavior();

protected :

    //## auto_generated
    void initStatechart();
    
    //## auto_generated
    void cleanUpRelations();
    
    ////    Relations and components    ////
    
    OMCollection<Subscriber*> itsSubscriberList;		//## link itsSubscriberList
    
    ////    Framework operations    ////

public :

    //## auto_generated
    void _removeItsSubscriberList(Subscriber* p_Subscriber);
    
    //## auto_generated
    void _clearItsSubscriberList();
    
    ////    Framework    ////
    
    //## operation Publisher()
    Publisher(IOxfActive* theActiveContext = 0);

protected :

    //## auto_generated
    void cancelTimeouts();
    
    //## auto_generated
    bool cancelTimeout(const IOxfTimeout* arg);

public :

    //## operation broadcastMessage()
    void broadcastMessage();
    
    //## operation regSubscriber(Subscriber)
    void regSubscriber(const Subscriber* pSubscriber);
    
    // rootState:
    //## statechart_method
    inline bool rootState_IN() const;
    
    //## statechart_method
    virtual void rootState_entDef();
    
    //## statechart_method
    virtual IOxfReactive::TakeEventStatus rootState_processEvent();
    
    // registering:
    //## statechart_method
    inline bool registering_IN() const;
    
    // publishing:
    //## statechart_method
    inline bool publishing_IN() const;
    
    // idle:
    //## statechart_method
    inline bool idle_IN() const;

protected :

//#[ ignore
    enum Publisher_Enum {
        OMNonState = 0,
        registering = 1,
        publishing = 2,
        idle = 3
    };
    
    int rootState_subState;
    
    int rootState_active;
    
    IOxfTimeout* rootState_timeout;
//#]
};

#ifdef _OMINSTRUMENT
//#[ ignore
class OMAnimatedPublisher : virtual public AOMInstance {
    DECLARE_REACTIVE_META(Publisher, OMAnimatedPublisher)
    
    ////    Framework operations    ////
    
public :

    virtual void serializeRelations(AOMSRelations* aomsRelations) const;
    
    //## statechart_method
    void rootState_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void registering_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void publishing_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void idle_serializeStates(AOMSState* aomsState) const;
};
//#]
#endif // _OMINSTRUMENT

inline bool Publisher::rootState_IN() const {
    return true;
}

inline bool Publisher::registering_IN() const {
    return rootState_subState == registering;
}

inline bool Publisher::publishing_IN() const {
    return rootState_subState == publishing;
}

inline bool Publisher::idle_IN() const {
    return rootState_subState == idle;
}

#endif
/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\Publisher.h
*********************************************************************/
