/*********************************************************************
	Rhapsody	: 8.0.6 
	Login		: GB080220
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: Subscriber
//!	Generated Date	: Fri, 18, Dec 2015  
	File Path	: DefaultComponent\DefaultConfig\Subscriber.h
*********************************************************************/

#ifndef Subscriber_H
#define Subscriber_H

//## auto_generated
#include <oxf\oxf.h>
//## auto_generated
#include <aom\aom.h>
//## auto_generated
#include "Default.h"
//## auto_generated
#include <oxf\omthread.h>
//## auto_generated
#include <oxf\omreactive.h>
//## auto_generated
#include <oxf\state.h>
//## auto_generated
#include <oxf\event.h>
//## auto_generated
#include <oxf\omlist.h>
//## operation addPublisher(Publisher)
class Publisher;

//## package Default

//## class Subscriber
class Subscriber : public OMReactive {
    ////    Friends    ////
    
public :

#ifdef _OMINSTRUMENT
    friend class OMAnimatedSubscriber;
#endif // _OMINSTRUMENT

    ////    Constructors and destructors    ////
    
    //## operation Subscriber(char*)
    Subscriber(char* pName, IOxfActive* theActiveContext = 0);
    
    //## auto_generated
    ~Subscriber();
    
    ////    Additional operations    ////
    
    //## auto_generated
    OMIterator<Publisher*> getItsPublisher() const;
    
    //## auto_generated
    void removeItsPublisher(Publisher* p_Publisher);
    
    //## auto_generated
    void clearItsPublisher();
    
    //## auto_generated
    virtual bool startBehavior();

protected :

    //## auto_generated
    void initStatechart();
    
    //## auto_generated
    void cleanUpRelations();
    
    //## auto_generated
    void cancelTimeouts();
    
    //## auto_generated
    bool cancelTimeout(const IOxfTimeout* arg);
    
    ////    Relations and components    ////
    
    OMList<Publisher*> itsPublisher;		//## link itsPublisher
    
    ////    Framework operations    ////

public :

    //## auto_generated
    void _removeItsPublisher(Publisher* p_Publisher);
    
    //## auto_generated
    void _clearItsPublisher();
    
    ////    Framework    ////
    
    //## auto_generated
    Subscriber(IOxfActive* theActiveContext = 0);
    
    //## operation addPublisher(Publisher)
    void addPublisher(const Publisher* pPublisher);
    
    //## auto_generated
    char* getName() const;
    
    //## auto_generated
    void setName(char* p_name);

protected :

    char* name;		//## attribute name

public :

    // rootState:
    //## statechart_method
    inline bool rootState_IN() const;
    
    //## statechart_method
    virtual void rootState_entDef();
    
    //## statechart_method
    virtual IOxfReactive::TakeEventStatus rootState_processEvent();
    
    // recevingMessages:
    //## statechart_method
    inline bool recevingMessages_IN() const;
    
    // idle:
    //## statechart_method
    inline bool idle_IN() const;

protected :

//#[ ignore
    enum Subscriber_Enum {
        OMNonState = 0,
        recevingMessages = 1,
        idle = 2
    };
    
    int rootState_subState;
    
    int rootState_active;
    
    IOxfTimeout* rootState_timeout;
//#]
};

#ifdef _OMINSTRUMENT
//#[ ignore
class OMAnimatedSubscriber : virtual public AOMInstance {
    DECLARE_REACTIVE_META(Subscriber, OMAnimatedSubscriber)
    
    ////    Framework operations    ////
    
public :

    virtual void serializeAttributes(AOMSAttributes* aomsAttributes) const;
    
    virtual void serializeRelations(AOMSRelations* aomsRelations) const;
    
    //## statechart_method
    void rootState_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void recevingMessages_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void idle_serializeStates(AOMSState* aomsState) const;
};
//#]
#endif // _OMINSTRUMENT

inline bool Subscriber::rootState_IN() const {
    return true;
}

inline bool Subscriber::recevingMessages_IN() const {
    return rootState_subState == recevingMessages;
}

inline bool Subscriber::idle_IN() const {
    return rootState_subState == idle;
}

#endif
/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\Subscriber.h
*********************************************************************/
